 
#include "TArtMethodManager.hh"
#include "TArtMethodLoad.hh"
#include "TArtMethodAnalysis.hh"

#include "TArtRawEventObject.h"

#include <iostream>
#include <vector>

TArtMethodManager::TArtMethodManager()
{;}

TArtMethodManager::~TArtMethodManager()
{
  TArtMethodLoadArray::iterator itlm = fMethodLoadArray.begin();
  while(itlm != fMethodLoadArray.end()){
    delete (*itlm);
    ++itlm;
  }

  TArtMethodAnalysisArray::iterator itam = fMethodAnalysisArray.begin();
  while(itam != fMethodAnalysisArray.end()){
    delete (*itam);
    ++itam;
  }
}

void TArtMethodManager::AddMethodLoad(TArtMethodLoad* loadmethod)
{
  std::cout << "AddMethodLoad" << std::endl;

  fMethodLoadArray.push_back(loadmethod);
}

void TArtMethodManager::AddMethodAnalysis(TArtMethodAnalysis* independentmethod)
{
  std::cout << "AddMethodAnalysis" << std::endl;

  fMethodAnalysisArray.push_back(independentmethod);
}

void TArtMethodManager::DoAll(TArtRawEventObject *event)
{
  TArtMethodLoadArray::iterator itlm = fMethodLoadArray.begin();
  while(itlm != fMethodLoadArray.end()){
    (*(*itlm))(event);
    ++itlm;
  }

  TArtMethodAnalysisArray::iterator itam = fMethodAnalysisArray.begin();
  while(itam != fMethodAnalysisArray.end()){
    (*(*itam))();
    ++itam;
  }
}
